; SawTech-Aqua/theme.jl

;; Copyright (C) 2000 Etienne Casaert <etienne@linuxbe.org>
;; Graphics made by Cytrix <ejvend@uswest.net>.
;; Modified into SawTech-Aqua by Dean <dean@thestuff.net>
;; This theme is the sawmill version of the Enlightenment theme
;; "E-Tech-Hydro" made by Cytrix.

(def-frame-class sticky-button '((cursor . left_ptr))
  (bind-keys sticky-button-keymap
    "Button1-Off" 'toggle-window-sticky))

(let*
    (
     ;; fonts
     (font-colors (list "grey27" "black"))
     
     ;; pixmaps

     ;; 60x18
     (titlebar-top-left-images (list (make-image "titlebartli.png") (make-image "titlebartl.png")))

     ;; 78x18
     (titlebar-top-right-images (list (make-image "titlebartri.png") (make-image "titlebartr.png")))

     ;; 1x18
     (titlebar-images (list (make-image "titlebari.png") (make-image "titlebar.png")))

     ;; 30x18
     (transient-titlebar-top-right-images (list (make-image "t-titlebartri.png") (make-image "t-titlebartr.png")))

     ;; 20x13
     (corner-bottom-left-images (make-image "cornerbl.png"))
     (corner-bottom-right-images (make-image "cornerbr.png"))
     
     ;; 1x13
     (bottom-images (make-image "bottom.png"))

     ;; 14x15
     (close-images (list (make-image "buttonclosei.png")
			 (make-image "buttonclose.png")
                         (make-image "buttoncloseh.png")
			 (make-image "buttonclosec.png")))
     (menu-images (list (make-image "buttonmenui.png")
                        (make-image "buttonmenu.png")
                        (make-image "buttonmenuh.png")
                        (make-image "buttonmenuc.png")))
     (maximize-images (list (make-image "buttonmaxi.png")
			    (make-image "buttonmax.png")
                            (make-image "buttonmaxh.png")
			    (make-image "buttonmaxc.png")))
     (iconify-images (list (make-image "buttonmini.png")
			   (make-image "buttonmin.png")
                           (make-image "buttonminh.png")
			   (make-image "buttonminc.png")))
     (pin-on-images (list (make-image "buttonpini.png")
     	                  (make-image "buttonpina.png")
                          (make-image "buttonpinh.png")
                          (make-image "buttonpinc.png")))
     (pin-off-images (list (make-image "buttonpini.png")
     	                   (make-image "buttonpin.png")
                           (make-image "buttonpinh.png")
                           (make-image "buttonpinc.png")))

     ;; 15x14
     (corner-top-left-images (make-image "cornertl.png"))
     (corner-top-right-images (make-image "cornertr.png"))

     ;; 15x1
     (left-images (make-image "left.png"))
     (right-images (make-image "right.png"))

     ;; 15x4
     (left-bottom-images (make-image "leftb.png"))

     ;; 15x10
     (right-bottom-images (make-image "rightb.png"))

     ;; frame layout

     (frame-normal `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 45)
               (right-edge . 63)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

              ;; top-left corner
              ((background . ,corner-top-left-images)
               (top-edge . 0)
               (left-edge . -15)
               (class . top-left-corner))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 4)
	       (class . left-border))

	      ;; top-right titlebar
	      ((background . ,titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

              ;; top-right corner
              ((background . ,corner-top-right-images)
               (right-edge . -15)
               (top-edge . 0)
               (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 10)
	       (class . right-border))

              ;; bottom-left border
              ((background . ,left-bottom-images)
               (left-edge . -14)
               (bottom-edge . 0)
               (class . bottom-left-corner))

              ;; bottom-right border
              ((background . , right-bottom-images)
               (right-edge . -15)
               (bottom-edge . 0)
               (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -13)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-right-corner))

              ;; pin button
              ((background . ,pin-off-images)
               (right-edge . 25)
               (top-edge . -17)
               (class . sticky-button))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 11)
	       (top-edge . -17)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . -3)
	       (top-edge . -17)
	       (class . maximize-button))))
  
     (frame-pinned `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 45)
               (right-edge . 63)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

              ;; top-left corner
              ((background . ,corner-top-left-images)
               (top-edge . 0)
               (left-edge . -15)
               (class . top-left-corner))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 4)
	       (class . left-border))

	      ;; top-right titlebar
	      ((background . ,titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

              ;; top-right corner
              ((background . ,corner-top-right-images)
               (right-edge . -15)
               (top-edge . 0)
               (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 10)
	       (class . right-border))

              ;; bottom-left border
              ((background . ,left-bottom-images)
               (left-edge . -14)
               (bottom-edge . 0)
               (class . bottom-left-corner))

              ;; bottom-right border
              ((background . , right-bottom-images)
               (right-edge . -15)
               (bottom-edge . 0)
               (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -13)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-right-corner))

              ;; pin button
              ((background . ,pin-on-images)
               (right-edge . 25)
               (top-edge . -17)
               (class . sticky-button))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 11)
	       (top-edge . -17)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . -3)
	       (top-edge . -17)
	       (class . maximize-button))))
  
     (shaped-frame-normal `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 44)
	       (right-edge . 63)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

	      ;; top-right titlebar
	      ((background . ,titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (top-edge . 0)
	       (class . title))

              ;; pin button
              ((background . ,pin-off-images)
               (right-edge . 25)
               (top-edge . -17)
               (class . sticky-button))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 11)
	       (top-edge . -17)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . -3)
	       (top-edge . -17)
	       (class . maximize-button))))

     (shaped-frame-pinned `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 44)
	       (right-edge . 63)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

	      ;; top-right titlebar
	      ((background . ,titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (top-edge . 0)
	       (class . title))

              ;; pin button
              ((background . ,pin-on-images)
               (right-edge . 25)
               (top-edge . -17)
               (class . sticky-button))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 11)
	       (top-edge . -17)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . -3)
	       (top-edge . -17)
	       (class . maximize-button))))
  
     (transient-frame `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 44)
	       (right-edge . 15)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

              ;; top-left corner
              ((background . ,corner-top-left-images)
               (top-edge . 0)
               (left-edge . -15)
               (class . top-left-corner))

	      ;; left border
	      ((background . ,left-images)
	       (left-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 4)
	       (class . left-border))

	      ;; top-right titlebar
	      ((background . ,transient-titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

              ;; top-right corner
              ((background . ,corner-top-right-images)
               (right-edge . -15)
               (top-edge . 0)
               (class . top-right-corner))

	      ;; right border
	      ((background . ,right-images)
	       (right-edge . -15)
	       (top-edge . 14)
	       (bottom-edge . 10)
	       (class . right-border))

              ;; bottom-left border
              ((background . ,left-bottom-images)
               (left-edge . -14)
               (bottom-edge . 0)
               (class . bottom-left-corner))

              ;; bottom-right border
              ((background . , right-bottom-images)
               (right-edge . -15)
               (bottom-edge . 0)
               (class . bottom-right-corner))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -13)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (bottom-edge . -13)
	       (class . bottom-right-corner))))
  
     (shaped-transient-frame `(
              ;; top-left titlebar
              ((background . ,titlebar-top-left-images)
       	       (left-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; titlebar
	      ((background . ,titlebar-images)
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 5)
	       (y-justify . -5)
	       (top-edge . -18)
	       (left-edge . 44)
	       (right-edge . 15)
	       (class . title))

	      ;; close button
	      ((background . ,close-images)
	       (top-edge . -17)
	       (left-edge . -4)
	       (class . close-button))

              ;; menu button
              ((background . ,menu-images)
               (top-edge . -18)
               (left-edge . 22)
               (class . menu-button))

	      ;; top-right titlebar
	      ((background . ,transient-titlebar-top-right-images)
	       (right-edge . -15)
	       (top-edge . -18)
	       (class . title))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-left corner
	      ((background . ,corner-bottom-left-images)
	       (left-edge . -15)
	       (top-edge . 0)
	       (class . title))

	      ;; bottom-right corner
	      ((background . ,corner-bottom-right-images)
	       (right-edge . -15)
	       (top-edge . 0)
	       (class . title)))))
  
  (add-frame-style 'SawTech-Aqua
		   (lambda (w type)
		     (cond ((eq type 'shaded)
                            (cond ((window-get w 'sticky)
                                   shaped-frame-pinned)
                                  (t
                                   shaped-frame-normal)))

			   ((eq type 'transient)
			    transient-frame)
                           ((eq type 'shaded-transient)
                            shaped-transient-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
                            (cond ((window-get w 'sticky)
                                   frame-pinned)
                                  (t
                                   frame-normal))))))

  (call-after-state-changed '(sticky)
                            (lambda (w)
			      (reframe-one-window w))))
